/* Module auth */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#define EXPORT_BOOLEAN
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/mig_support.h>

#ifndef	mig_internal
#define	mig_internal	static
#endif

#ifndef	mig_external
#define mig_external
#endif

#ifndef	TypeCheck
#define	TypeCheck 1
#endif

#ifndef	UseExternRCSId
#define	UseExternRCSId		1
#endif

#define msgh_request_port	msgh_local_port
#define MACH_MSGH_BITS_REQUEST(bits)	MACH_MSGH_BITS_LOCAL(bits)
#define msgh_reply_port		msgh_remote_port
#define MACH_MSGH_BITS_REPLY(bits)	MACH_MSGH_BITS_REMOTE(bits)

#include <mach/std_types.h>
#include <mach/mach_types.h>
#include <device/device_types.h>
#include <device/net_status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <sys/resource.h>
#include <sys/utsname.h>
#include <hurd/hurd_types.h>
#include "auth_mig.h"

/* Routine auth_getids */
mig_internal void _Xauth_getids
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
		mach_msg_type_long_t euidsType;
		uid_t euids[512];
		mach_msg_type_long_t auidsType;
		uid_t auids[512];
		mach_msg_type_long_t egidsType;
		uid_t egids[512];
		mach_msg_type_long_t agidsType;
		uid_t agids[512];
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_auth_getids
		(authhandle_t handle, idarray_t *euids, mach_msg_type_number_t *euidsCnt, idarray_t *auids, mach_msg_type_number_t *auidsCnt, idarray_t *egids, mach_msg_type_number_t *egidsCnt, idarray_t *agids, mach_msg_type_number_t *agidsCnt);

	boolean_t msgh_simple;
	unsigned int msgh_size;
	unsigned int msgh_size_delta;

	static const mach_msg_type_long_t euidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t auidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t egidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t agidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	authhandle_t handle;
	mach_msg_type_number_t euidsCnt;
	uid_t auids[512];
	mach_msg_type_number_t auidsCnt;
	uid_t egids[512];
	mach_msg_type_number_t egidsCnt;
	uid_t agids[512];
	mach_msg_type_number_t agidsCnt;

	uid_t *euidsP;
	uid_t *auidsP;
	uid_t *egidsP;
	uid_t *agidsP;

#if	TypeCheck
	if ((In0P->Head.msgh_size != 24) ||
	    (In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	handle = auth_port_to_handle(In0P->Head.msgh_request_port);

	euidsP = OutP->euids;
	euidsCnt = 512;

	auidsP = auids;
	auidsCnt = 512;

	egidsP = egids;
	egidsCnt = 512;

	agidsP = agids;
	agidsCnt = 512;

	OutP->RetCode = S_auth_getids(handle, &euidsP, &euidsCnt, &auidsP, &auidsCnt, &egidsP, &egidsCnt, &agidsP, &agidsCnt);
	ports_port_deref(handle);
	if (OutP->RetCode != KERN_SUCCESS)
		return;

	msgh_simple = TRUE;

	OutP->euidsType = euidsType;
	if (euidsP != OutP->euids) {
		OutP->euidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->euids) = euidsP;
		msgh_simple = FALSE;
	}

	OutP->euidsType.msgtl_number = euidsCnt;
	msgh_size_delta = (OutP->euidsType.msgtl_header.msgt_inline) ? 4 * euidsCnt : sizeof(uid_t *);
	msgh_size = 80 + msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->auidsType = auidsType;

	if (auidsP != auids) {
		OutP->auidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->auids) = auidsP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->auids, auids, 4 * auidsCnt);
	}

	OutP->auidsType.msgtl_number = auidsCnt;
	msgh_size_delta = (OutP->auidsType.msgtl_header.msgt_inline) ? 4 * auidsCnt : sizeof(uid_t *);
	msgh_size += msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->egidsType = egidsType;

	if (egidsP != egids) {
		OutP->egidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->egids) = egidsP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->egids, egids, 4 * egidsCnt);
	}

	OutP->egidsType.msgtl_number = egidsCnt;
	msgh_size_delta = (OutP->egidsType.msgtl_header.msgt_inline) ? 4 * egidsCnt : sizeof(uid_t *);
	msgh_size += msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->agidsType = agidsType;

	if (agidsP != agids) {
		OutP->agidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->agids) = agidsP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->agids, agids, 4 * agidsCnt);
	}

	OutP->agidsType.msgtl_number = agidsCnt;
	msgh_size += (OutP->agidsType.msgtl_header.msgt_inline) ? 4 * agidsCnt : sizeof(uid_t *);

	OutP = (Reply *) OutHeadP;
	if (!msgh_simple)
		OutP->Head.msgh_bits |= MACH_MSGH_BITS_COMPLEX;
	OutP->Head.msgh_size = msgh_size;
}

/* Routine auth_makeauth */
mig_internal void _Xauth_makeauth
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_long_t other_handlesType;
		mach_port_t other_handles[512];
		mach_msg_type_long_t euidsType;
		uid_t euids[512];
		mach_msg_type_long_t auidsType;
		uid_t auids[512];
		mach_msg_type_long_t egidsType;
		uid_t egids[512];
		mach_msg_type_long_t agidsType;
		uid_t agids[512];
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
		mach_msg_type_t newhandleType;
		mach_port_t newhandle;
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Request *In1P;
	register Request *In2P;
	register Request *In3P;
	register Request *In4P;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_auth_makeauth
		(authhandle_t handle, portarray_t other_handles, mach_msg_type_number_t other_handlesCnt, idarray_t euids, mach_msg_type_number_t euidsCnt, idarray_t auids, mach_msg_type_number_t auidsCnt, idarray_t egids, mach_msg_type_number_t egidsCnt, idarray_t agids, mach_msg_type_number_t agidsCnt, mach_port_t *newhandle);

	unsigned int msgh_size;
	unsigned int msgh_size_delta;

	static const mach_msg_type_t newhandleType = {
		/* msgt_name = */		20,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	authhandle_t handle;

#if	TypeCheck
	msgh_size = In0P->Head.msgh_size;
	if ((msgh_size < 84) ||
	    !(In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if ((In0P->other_handlesType.msgtl_header.msgt_longform != TRUE) ||
	    (In0P->other_handlesType.msgtl_name != 17) ||
	    (In0P->other_handlesType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In0P->other_handlesType.msgtl_header.msgt_inline) ? 4 * In0P->other_handlesType.msgtl_number : sizeof(mach_port_t *);
#if	TypeCheck
	if (msgh_size < 84 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In1P = (Request *) ((char *) In0P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In1P->euidsType.msgtl_header.msgt_longform != TRUE) ||
	    (In1P->euidsType.msgtl_name != 2) ||
	    (In1P->euidsType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In1P->euidsType.msgtl_header.msgt_inline) ? 4 * In1P->euidsType.msgtl_number : sizeof(uid_t *);
#if	TypeCheck
	if (msgh_size < 84 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In2P = (Request *) ((char *) In1P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In2P->auidsType.msgtl_header.msgt_longform != TRUE) ||
	    (In2P->auidsType.msgtl_name != 2) ||
	    (In2P->auidsType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In2P->auidsType.msgtl_header.msgt_inline) ? 4 * In2P->auidsType.msgtl_number : sizeof(uid_t *);
#if	TypeCheck
	if (msgh_size < 84 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In3P = (Request *) ((char *) In2P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In3P->egidsType.msgtl_header.msgt_longform != TRUE) ||
	    (In3P->egidsType.msgtl_name != 2) ||
	    (In3P->egidsType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In3P->egidsType.msgtl_header.msgt_inline) ? 4 * In3P->egidsType.msgtl_number : sizeof(uid_t *);
#if	TypeCheck
	if (msgh_size < 84 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In4P = (Request *) ((char *) In3P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In4P->agidsType.msgtl_header.msgt_longform != TRUE) ||
	    (In4P->agidsType.msgtl_name != 2) ||
	    (In4P->agidsType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (msgh_size != 84 + ((In4P->agidsType.msgtl_header.msgt_inline) ? 4 * In4P->agidsType.msgtl_number : sizeof(uid_t *)))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	handle = auth_port_to_handle(In0P->Head.msgh_request_port);

	OutP->RetCode = S_auth_makeauth(handle, (In0P->other_handlesType.msgtl_header.msgt_inline) ? In0P->other_handles : *((mach_port_t **)In0P->other_handles), In0P->other_handlesType.msgtl_number, (In1P->euidsType.msgtl_header.msgt_inline) ? In1P->euids : *((uid_t **)In1P->euids), In1P->euidsType.msgtl_number, (In2P->auidsType.msgtl_header.msgt_inline) ? In2P->auids : *((uid_t **)In2P->auids), In2P->auidsType.msgtl_number, (In3P->egidsType.msgtl_header.msgt_inline) ? In3P->egids : *((uid_t **)In3P->egids), In3P->egidsType.msgtl_number, (In4P->agidsType.msgtl_header.msgt_inline) ? In4P->agids : *((uid_t **)In4P->agids), In4P->agidsType.msgtl_number, &OutP->newhandle);
	if (!In4P->agidsType.msgtl_header.msgt_inline)
		__mig_deallocate(* (vm_offset_t *) In4P->agids, 4 *  In4P->agidsType.msgtl_number);
	if (!In3P->egidsType.msgtl_header.msgt_inline)
		__mig_deallocate(* (vm_offset_t *) In3P->egids, 4 *  In3P->egidsType.msgtl_number);
	if (!In2P->auidsType.msgtl_header.msgt_inline)
		__mig_deallocate(* (vm_offset_t *) In2P->auids, 4 *  In2P->auidsType.msgtl_number);
	if (!In1P->euidsType.msgtl_header.msgt_inline)
		__mig_deallocate(* (vm_offset_t *) In1P->euids, 4 *  In1P->euidsType.msgtl_number);
	if (!In0P->other_handlesType.msgtl_header.msgt_inline)
		__mig_deallocate(* (vm_offset_t *) In0P->other_handles, 4 *  In0P->other_handlesType.msgtl_number);
	ports_port_deref(handle);
	if (OutP->RetCode != KERN_SUCCESS)
		return;

	OutP->Head.msgh_bits |= MACH_MSGH_BITS_COMPLEX;
	OutP->Head.msgh_size = 40;

	OutP->newhandleType = newhandleType;
}

/* Routine auth_user_authenticate */
mig_internal void _Xauth_user_authenticate
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t rendezvousType;
		mach_port_t rendezvous;
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
		mach_msg_type_t newportType;
		mach_port_t newport;
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_auth_user_authenticate
		(authhandle_t handle, mach_port_t reply, mach_msg_type_name_t replyPoly, mach_port_t rendezvous, mach_port_t *newport, mach_msg_type_name_t *newportPoly);

	boolean_t msgh_simple;
	static const mach_msg_type_t rendezvousCheck = {
		/* msgt_name = */		17,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t newportType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	authhandle_t handle;
	mach_msg_type_name_t newportPoly;

#if	TypeCheck
	if ((In0P->Head.msgh_size != 32) ||
	    !(In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (* (int *) &In0P->rendezvousType != * (int *) &rendezvousCheck)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	handle = auth_port_to_handle(In0P->Head.msgh_request_port);

	OutP->RetCode = S_auth_user_authenticate(handle, In0P->Head.msgh_reply_port, MACH_MSGH_BITS_REPLY(In0P->Head.msgh_bits), In0P->rendezvous, &OutP->newport, &newportPoly);
	ports_port_deref(handle);
	if (OutP->RetCode != KERN_SUCCESS)
		return;

	msgh_simple = TRUE;
	OutP->Head.msgh_size = 40;

	OutP->newportType = newportType;

	if (MACH_MSG_TYPE_PORT_ANY(newportPoly))
		msgh_simple = FALSE;

	OutP->newportType.msgt_name = newportPoly;

	if (!msgh_simple)
		OutP->Head.msgh_bits |= MACH_MSGH_BITS_COMPLEX;
}

/* Routine auth_server_authenticate */
mig_internal void _Xauth_server_authenticate
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t rendezvousType;
		mach_port_t rendezvous;
		mach_msg_type_t newportType;
		mach_port_t newport;
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
		mach_msg_type_long_t euidsType;
		uid_t euids[512];
		mach_msg_type_long_t auidsType;
		uid_t auids[512];
		mach_msg_type_long_t egidsType;
		uid_t egids[512];
		mach_msg_type_long_t agidsType;
		uid_t agids[512];
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_auth_server_authenticate
		(authhandle_t handle, mach_port_t reply, mach_msg_type_name_t replyPoly, mach_port_t rendezvous, mach_port_t newport, mach_msg_type_name_t newportPoly, idarray_t *euids, mach_msg_type_number_t *euidsCnt, idarray_t *auids, mach_msg_type_number_t *auidsCnt, idarray_t *egids, mach_msg_type_number_t *egidsCnt, idarray_t *agids, mach_msg_type_number_t *agidsCnt);

	boolean_t msgh_simple;
	unsigned int msgh_size;
	unsigned int msgh_size_delta;

	static const mach_msg_type_t rendezvousCheck = {
		/* msgt_name = */		17,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_long_t euidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t auidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t egidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t agidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	authhandle_t handle;
	mach_msg_type_number_t euidsCnt;
	uid_t auids[512];
	mach_msg_type_number_t auidsCnt;
	uid_t egids[512];
	mach_msg_type_number_t egidsCnt;
	uid_t agids[512];
	mach_msg_type_number_t agidsCnt;

	uid_t *euidsP;
	uid_t *auidsP;
	uid_t *egidsP;
	uid_t *agidsP;

#if	TypeCheck
	if ((In0P->Head.msgh_size != 40) ||
	    !(In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (* (int *) &In0P->rendezvousType != * (int *) &rendezvousCheck)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if ((In0P->newportType.msgt_inline != TRUE) ||
	    (In0P->newportType.msgt_longform != FALSE) ||
	    (In0P->newportType.msgt_number != 1) ||
	    (In0P->newportType.msgt_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	handle = auth_port_to_handle(In0P->Head.msgh_request_port);

	euidsP = OutP->euids;
	euidsCnt = 512;

	auidsP = auids;
	auidsCnt = 512;

	egidsP = egids;
	egidsCnt = 512;

	agidsP = agids;
	agidsCnt = 512;

	OutP->RetCode = S_auth_server_authenticate(handle, In0P->Head.msgh_reply_port, MACH_MSGH_BITS_REPLY(In0P->Head.msgh_bits), In0P->rendezvous, In0P->newport, In0P->newportType.msgt_name, &euidsP, &euidsCnt, &auidsP, &auidsCnt, &egidsP, &egidsCnt, &agidsP, &agidsCnt);
	ports_port_deref(handle);
	if (OutP->RetCode != KERN_SUCCESS)
		return;

	msgh_simple = TRUE;

	OutP->euidsType = euidsType;
	if (euidsP != OutP->euids) {
		OutP->euidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->euids) = euidsP;
		msgh_simple = FALSE;
	}

	OutP->euidsType.msgtl_number = euidsCnt;
	msgh_size_delta = (OutP->euidsType.msgtl_header.msgt_inline) ? 4 * euidsCnt : sizeof(uid_t *);
	msgh_size = 80 + msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->auidsType = auidsType;

	if (auidsP != auids) {
		OutP->auidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->auids) = auidsP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->auids, auids, 4 * auidsCnt);
	}

	OutP->auidsType.msgtl_number = auidsCnt;
	msgh_size_delta = (OutP->auidsType.msgtl_header.msgt_inline) ? 4 * auidsCnt : sizeof(uid_t *);
	msgh_size += msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->egidsType = egidsType;

	if (egidsP != egids) {
		OutP->egidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->egids) = egidsP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->egids, egids, 4 * egidsCnt);
	}

	OutP->egidsType.msgtl_number = egidsCnt;
	msgh_size_delta = (OutP->egidsType.msgtl_header.msgt_inline) ? 4 * egidsCnt : sizeof(uid_t *);
	msgh_size += msgh_size_delta;
	OutP = (Reply *) ((char *) OutP + msgh_size_delta - 2048);

	OutP->agidsType = agidsType;

	if (agidsP != agids) {
		OutP->agidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)OutP->agids) = agidsP;
		msgh_simple = FALSE;
	}
	else {
		memcpy(OutP->agids, agids, 4 * agidsCnt);
	}

	OutP->agidsType.msgtl_number = agidsCnt;
	msgh_size += (OutP->agidsType.msgtl_header.msgt_inline) ? 4 * agidsCnt : sizeof(uid_t *);

	OutP = (Reply *) OutHeadP;
	if (!msgh_simple)
		OutP->Head.msgh_bits |= MACH_MSGH_BITS_COMPLEX;
	OutP->Head.msgh_size = msgh_size;
}

static mig_routine_t auth_server_routines[] = {
		_Xauth_getids,
		_Xauth_makeauth,
		_Xauth_user_authenticate,
		_Xauth_server_authenticate,
};

mig_external boolean_t auth_server
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	register mach_msg_header_t *InP =  InHeadP;
	register mig_reply_header_t *OutP = (mig_reply_header_t *) OutHeadP;

	static const mach_msg_type_t RetCodeType = {
		/* msgt_name = */		MACH_MSG_TYPE_INTEGER_32,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	register mig_routine_t routine;

	OutP->Head.msgh_bits = MACH_MSGH_BITS(MACH_MSGH_BITS_REPLY(InP->msgh_bits), 0);
	OutP->Head.msgh_size = sizeof *OutP;
	OutP->Head.msgh_remote_port = InP->msgh_reply_port;
	OutP->Head.msgh_local_port = MACH_PORT_NULL;
	OutP->Head.msgh_seqno = 0;
	OutP->Head.msgh_id = InP->msgh_id + 100;

	OutP->RetCodeType = RetCodeType;

	if ((InP->msgh_id > 25003) || (InP->msgh_id < 25000) ||
	    ((routine = auth_server_routines[InP->msgh_id - 25000]) == 0)) {
		OutP->RetCode = MIG_BAD_ID;
		return FALSE;
	}
	(*routine) (InP, &OutP->Head);
	return TRUE;
}

mig_external mig_routine_t auth_server_routine
	(const mach_msg_header_t *InHeadP)
{
	register int msgh_id;

	msgh_id = InHeadP->msgh_id - 25000;

	if ((msgh_id > 3) || (msgh_id < 0))
		return 0;

	return auth_server_routines[msgh_id];
}

