#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#include "auth_reply_U.h"
#define EXPORT_BOOLEAN
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/message.h>
#include <mach/notify.h>
#include <mach/mach_types.h>
#include <mach/mig_errors.h>
#include <mach/mig_support.h>
#include <mach/msg_type.h>
/* LINTLIBRARY */

#ifndef	mig_internal
#define	mig_internal	static
#endif

#ifndef	mig_external
#define mig_external
#endif

#ifndef	TypeCheck
#define	TypeCheck 1
#endif

#ifndef	UseExternRCSId
#define	UseExternRCSId		1
#endif

#define msgh_request_port	msgh_remote_port
#define msgh_reply_port		msgh_local_port

#include <mach/std_types.h>
#include <mach/mach_types.h>
#include <device/device_types.h>
#include <device/net_status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <sys/resource.h>
#include <sys/utsname.h>
#include <hurd/hurd_types.h>

/* SimpleRoutine auth_user_authenticate_reply */
mig_external kern_return_t auth_user_authenticate_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code,
	mach_port_t newhandle,
	mach_msg_type_name_t newhandlePoly
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
		mach_msg_type_t newhandleType;
		mach_port_t newhandle;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	boolean_t msgh_simple = TRUE;

	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t newhandleType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	if (MACH_MSG_TYPE_PORT_ANY(reply_portPoly))
		msgh_simple = FALSE;

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->newhandleType = newhandleType;

	InP->newhandle = newhandle;

	if (MACH_MSG_TYPE_PORT_ANY(newhandlePoly))
		msgh_simple = FALSE;

	InP->newhandleType.msgt_name = newhandlePoly;

	InP->Head.msgh_bits = msgh_simple ?
		MACH_MSGH_BITS(reply_portPoly, 0) :
		(MACH_MSGH_BITS_COMPLEX|
		 MACH_MSGH_BITS(reply_portPoly, 0));
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 25102;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 40, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine auth_server_authenticate_reply */
mig_external kern_return_t auth_server_authenticate_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code,
	idarray_t gen_uids,
	mach_msg_type_number_t gen_uidsCnt,
	idarray_t aux_uids,
	mach_msg_type_number_t aux_uidsCnt,
	idarray_t gen_gids,
	mach_msg_type_number_t gen_gidsCnt,
	idarray_t aux_gids,
	mach_msg_type_number_t aux_gidsCnt
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
		mach_msg_type_long_t gen_uidsType;
		uid_t gen_uids[512];
		mach_msg_type_long_t aux_uidsType;
		uid_t aux_uids[512];
		mach_msg_type_long_t gen_gidsType;
		uid_t gen_gids[512];
		mach_msg_type_long_t aux_gidsType;
		uid_t aux_gids[512];
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	boolean_t msgh_simple = TRUE;
	unsigned int msgh_size;
	unsigned int msgh_size_delta;

	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_long_t gen_uidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t aux_uidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t gen_gidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	static const mach_msg_type_long_t aux_gidsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	2,
		/* msgtl_size = */	32,
		/* msgtl_number = */	512,
	};

	if (MACH_MSG_TYPE_PORT_ANY(reply_portPoly))
		msgh_simple = FALSE;

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->gen_uidsType = gen_uidsType;

	if (gen_uidsCnt > 512) {
		InP->gen_uidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)InP->gen_uids) = gen_uids;
		msgh_simple = FALSE;
	}
	else {
		memcpy(InP->gen_uids, gen_uids, 4 * gen_uidsCnt);
	}

	InP->gen_uidsType.msgtl_number = gen_uidsCnt;

	msgh_size_delta = (InP->gen_uidsType.msgtl_header.msgt_inline) ? 4 * gen_uidsCnt : sizeof(uid_t *);
	msgh_size = 80 + msgh_size_delta;
	InP = (Request *) ((char *) InP + msgh_size_delta - 2048);
	InP->aux_uidsType = aux_uidsType;

	if (aux_uidsCnt > 512) {
		InP->aux_uidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)InP->aux_uids) = aux_uids;
		msgh_simple = FALSE;
	}
	else {
		memcpy(InP->aux_uids, aux_uids, 4 * aux_uidsCnt);
	}

	InP->aux_uidsType.msgtl_number = aux_uidsCnt;

	msgh_size_delta = (InP->aux_uidsType.msgtl_header.msgt_inline) ? 4 * aux_uidsCnt : sizeof(uid_t *);
	msgh_size += msgh_size_delta;
	InP = (Request *) ((char *) InP + msgh_size_delta - 2048);
	InP->gen_gidsType = gen_gidsType;

	if (gen_gidsCnt > 512) {
		InP->gen_gidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)InP->gen_gids) = gen_gids;
		msgh_simple = FALSE;
	}
	else {
		memcpy(InP->gen_gids, gen_gids, 4 * gen_gidsCnt);
	}

	InP->gen_gidsType.msgtl_number = gen_gidsCnt;

	msgh_size_delta = (InP->gen_gidsType.msgtl_header.msgt_inline) ? 4 * gen_gidsCnt : sizeof(uid_t *);
	msgh_size += msgh_size_delta;
	InP = (Request *) ((char *) InP + msgh_size_delta - 2048);
	InP->aux_gidsType = aux_gidsType;

	if (aux_gidsCnt > 512) {
		InP->aux_gidsType.msgtl_header.msgt_inline = FALSE;
		*((uid_t **)InP->aux_gids) = aux_gids;
		msgh_simple = FALSE;
	}
	else {
		memcpy(InP->aux_gids, aux_gids, 4 * aux_gidsCnt);
	}

	InP->aux_gidsType.msgtl_number = aux_gidsCnt;

	msgh_size += (InP->aux_gidsType.msgtl_header.msgt_inline) ? 4 * aux_gidsCnt : sizeof(uid_t *);
	InP = &Mess.In;
	InP->Head.msgh_bits = msgh_simple ?
		MACH_MSGH_BITS(reply_portPoly, 0) :
		(MACH_MSGH_BITS_COMPLEX|
		 MACH_MSGH_BITS(reply_portPoly, 0));
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 25103;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, msgh_size, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}
