/* Module exec */

#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#define EXPORT_BOOLEAN
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/message.h>
#include <mach/mig_errors.h>
#include <mach/mig_support.h>

#ifndef	mig_internal
#define	mig_internal	static
#endif

#ifndef	mig_external
#define mig_external
#endif

#ifndef	TypeCheck
#define	TypeCheck 1
#endif

#ifndef	UseExternRCSId
#define	UseExternRCSId		1
#endif

#define msgh_request_port	msgh_local_port
#define MACH_MSGH_BITS_REQUEST(bits)	MACH_MSGH_BITS_LOCAL(bits)
#define msgh_reply_port		msgh_remote_port
#define MACH_MSGH_BITS_REPLY(bits)	MACH_MSGH_BITS_REMOTE(bits)

#include <mach/std_types.h>
#include <mach/mach_types.h>
#include <device/device_types.h>
#include <device/net_status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <sys/resource.h>
#include <sys/utsname.h>
#include <hurd/hurd_types.h>
#include "priv.h"

/* Routine exec_exec */
mig_internal void _Xexec_exec
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t fileType;
		mach_port_t file;
		mach_msg_type_t oldtaskType;
		mach_port_t oldtask;
		mach_msg_type_t flagsType;
		int flags;
		mach_msg_type_long_t argvType;
		char argv[2048];
		mach_msg_type_long_t envpType;
		char envp[2048];
		mach_msg_type_long_t dtableType;
		mach_port_t dtable[512];
		mach_msg_type_long_t portarrayType;
		mach_port_t portarray[512];
		mach_msg_type_long_t intarrayType;
		int intarray[512];
		mach_msg_type_long_t deallocnamesType;
		mach_port_t deallocnames[512];
		mach_msg_type_long_t destroynamesType;
		mach_port_t destroynames[512];
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Request *In1P;
	register Request *In2P;
	register Request *In3P;
	register Request *In4P;
	register Request *In5P;
	register Request *In6P;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_exec_exec
		(trivfs_protid_t execserver, mach_port_t file, mach_port_t oldtask, int flags, data_t argv, mach_msg_type_number_t argvCnt, boolean_t argvSCopy, data_t envp, mach_msg_type_number_t envpCnt, boolean_t envpSCopy, portarray_t dtable, mach_msg_type_number_t dtableCnt, boolean_t dtableSCopy, portarray_t portarray, mach_msg_type_number_t portarrayCnt, boolean_t portarraySCopy, intarray_t intarray, mach_msg_type_number_t intarrayCnt, boolean_t intarraySCopy, mach_port_array_t deallocnames, mach_msg_type_number_t deallocnamesCnt, mach_port_array_t destroynames, mach_msg_type_number_t destroynamesCnt);

	unsigned int msgh_size;
	unsigned int msgh_size_delta;

	static const mach_msg_type_t fileCheck = {
		/* msgt_name = */		17,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t oldtaskCheck = {
		/* msgt_name = */		17,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t flagsCheck = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	trivfs_protid_t execserver;

#if	TypeCheck
	msgh_size = In0P->Head.msgh_size;
	if ((msgh_size < 132) ||
	    !(In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (* (int *) &In0P->fileType != * (int *) &fileCheck)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (* (int *) &In0P->oldtaskType != * (int *) &oldtaskCheck)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (* (int *) &In0P->flagsType != * (int *) &flagsCheck)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if ((In0P->argvType.msgtl_header.msgt_longform != TRUE) ||
	    (In0P->argvType.msgtl_name != 8) ||
	    (In0P->argvType.msgtl_size != 8))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In0P->argvType.msgtl_header.msgt_inline) ? (In0P->argvType.msgtl_number + 3) & ~3 : sizeof(char *);
#if	TypeCheck
	if (msgh_size < 132 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In1P = (Request *) ((char *) In0P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In1P->envpType.msgtl_header.msgt_longform != TRUE) ||
	    (In1P->envpType.msgtl_name != 8) ||
	    (In1P->envpType.msgtl_size != 8))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In1P->envpType.msgtl_header.msgt_inline) ? (In1P->envpType.msgtl_number + 3) & ~3 : sizeof(char *);
#if	TypeCheck
	if (msgh_size < 132 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In2P = (Request *) ((char *) In1P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In2P->dtableType.msgtl_header.msgt_longform != TRUE) ||
	    (In2P->dtableType.msgtl_name != 17) ||
	    (In2P->dtableType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In2P->dtableType.msgtl_header.msgt_inline) ? 4 * In2P->dtableType.msgtl_number : sizeof(mach_port_t *);
#if	TypeCheck
	if (msgh_size < 132 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In3P = (Request *) ((char *) In2P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In3P->portarrayType.msgtl_header.msgt_longform != TRUE) ||
	    (In3P->portarrayType.msgtl_name != 17) ||
	    (In3P->portarrayType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In3P->portarrayType.msgtl_header.msgt_inline) ? 4 * In3P->portarrayType.msgtl_number : sizeof(mach_port_t *);
#if	TypeCheck
	if (msgh_size < 132 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In4P = (Request *) ((char *) In3P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In4P->intarrayType.msgtl_header.msgt_longform != TRUE) ||
	    (In4P->intarrayType.msgtl_name != 2) ||
	    (In4P->intarrayType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In4P->intarrayType.msgtl_header.msgt_inline) ? 4 * In4P->intarrayType.msgtl_number : sizeof(int *);
#if	TypeCheck
	if (msgh_size < 132 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In5P = (Request *) ((char *) In4P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In5P->deallocnamesType.msgtl_header.msgt_longform != TRUE) ||
	    (In5P->deallocnamesType.msgtl_name != 15) ||
	    (In5P->deallocnamesType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In5P->deallocnamesType.msgtl_header.msgt_inline) ? 4 * In5P->deallocnamesType.msgtl_number : sizeof(mach_port_t *);
#if	TypeCheck
	if (msgh_size < 132 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In6P = (Request *) ((char *) In5P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In6P->destroynamesType.msgtl_header.msgt_longform != TRUE) ||
	    (In6P->destroynamesType.msgtl_name != 15) ||
	    (In6P->destroynamesType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (msgh_size != 132 + ((In6P->destroynamesType.msgtl_header.msgt_inline) ? 4 * In6P->destroynamesType.msgtl_number : sizeof(mach_port_t *)))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	execserver = trivfs_begin_using_protid(In0P->Head.msgh_request_port);

	OutP->RetCode = S_exec_exec(execserver, In0P->file, In0P->oldtask, In0P->flags, (In0P->argvType.msgtl_header.msgt_inline) ? In0P->argv : *((char **)In0P->argv), In0P->argvType.msgtl_number, In0P->argvType.msgtl_header.msgt_inline, (In1P->envpType.msgtl_header.msgt_inline) ? In1P->envp : *((char **)In1P->envp), In1P->envpType.msgtl_number, In1P->envpType.msgtl_header.msgt_inline, (In2P->dtableType.msgtl_header.msgt_inline) ? In2P->dtable : *((mach_port_t **)In2P->dtable), In2P->dtableType.msgtl_number, In2P->dtableType.msgtl_header.msgt_inline, (In3P->portarrayType.msgtl_header.msgt_inline) ? In3P->portarray : *((mach_port_t **)In3P->portarray), In3P->portarrayType.msgtl_number, In3P->portarrayType.msgtl_header.msgt_inline, (In4P->intarrayType.msgtl_header.msgt_inline) ? In4P->intarray : *((int **)In4P->intarray), In4P->intarrayType.msgtl_number, In4P->intarrayType.msgtl_header.msgt_inline, (In5P->deallocnamesType.msgtl_header.msgt_inline) ? In5P->deallocnames : *((mach_port_t **)In5P->deallocnames), In5P->deallocnamesType.msgtl_number, (In6P->destroynamesType.msgtl_header.msgt_inline) ? In6P->destroynames : *((mach_port_t **)In6P->destroynames), In6P->destroynamesType.msgtl_number);
	if (!In6P->destroynamesType.msgtl_header.msgt_inline)
		__mig_deallocate(* (vm_offset_t *) In6P->destroynames, 4 *  In6P->destroynamesType.msgtl_number);
	if (!In5P->deallocnamesType.msgtl_header.msgt_inline)
		__mig_deallocate(* (vm_offset_t *) In5P->deallocnames, 4 *  In5P->deallocnamesType.msgtl_number);
	trivfs_end_using_protid(execserver);
}

/* Routine exec_init */
mig_internal void _Xexec_init
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t auth_handleType;
		auth_t auth_handle;
		mach_msg_type_t proc_serverType;
		mach_port_t proc_server;
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_exec_init
		(trivfs_protid_t execserver, auth_t auth_handle, mach_port_t proc_server);

	static const mach_msg_type_t auth_handleCheck = {
		/* msgt_name = */		17,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t proc_serverCheck = {
		/* msgt_name = */		17,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	trivfs_protid_t execserver;

#if	TypeCheck
	if ((In0P->Head.msgh_size != 40) ||
	    !(In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (* (int *) &In0P->auth_handleType != * (int *) &auth_handleCheck)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (* (int *) &In0P->proc_serverType != * (int *) &proc_serverCheck)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	execserver = trivfs_begin_using_protid(In0P->Head.msgh_request_port);

	OutP->RetCode = S_exec_init(execserver, In0P->auth_handle, In0P->proc_server);
	trivfs_end_using_protid(execserver);
}

/* SimpleRoutine exec_setexecdata */
mig_internal void _Xexec_setexecdata
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_long_t portsType;
		mach_port_t ports[512];
		mach_msg_type_long_t intsType;
		int ints[512];
	} Request;

	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t RetCodeType;
		kern_return_t RetCode;
	} Reply;

	register Request *In0P = (Request *) InHeadP;
	register Request *In1P;
	register Reply *OutP = (Reply *) OutHeadP;
	mig_external kern_return_t S_exec_setexecdata
		(trivfs_protid_t execserver, portarray_t ports, mach_msg_type_number_t portsCnt, boolean_t portsSCopy, intarray_t ints, mach_msg_type_number_t intsCnt, boolean_t intsSCopy);

	unsigned int msgh_size;
	unsigned int msgh_size_delta;

	trivfs_protid_t execserver;

#if	TypeCheck
	msgh_size = In0P->Head.msgh_size;
	if ((msgh_size < 48) ||
	    !(In0P->Head.msgh_bits & MACH_MSGH_BITS_COMPLEX))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if ((In0P->portsType.msgtl_header.msgt_longform != TRUE) ||
	    (In0P->portsType.msgtl_name != 17) ||
	    (In0P->portsType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	msgh_size_delta = (In0P->portsType.msgtl_header.msgt_inline) ? 4 * In0P->portsType.msgtl_number : sizeof(mach_port_t *);
#if	TypeCheck
	if (msgh_size < 48 + msgh_size_delta)
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
	msgh_size -= msgh_size_delta;
#endif	/* TypeCheck */

	In1P = (Request *) ((char *) In0P + msgh_size_delta - 2048);

#if	TypeCheck
	if ((In1P->intsType.msgtl_header.msgt_longform != TRUE) ||
	    (In1P->intsType.msgtl_name != 2) ||
	    (In1P->intsType.msgtl_size != 32))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

#if	TypeCheck
	if (msgh_size != 48 + ((In1P->intsType.msgtl_header.msgt_inline) ? 4 * In1P->intsType.msgtl_number : sizeof(int *)))
		{ OutP->RetCode = MIG_BAD_ARGUMENTS; return; }
#endif	/* TypeCheck */

	execserver = trivfs_begin_using_protid(In0P->Head.msgh_request_port);

	OutP->RetCode = S_exec_setexecdata(execserver, (In0P->portsType.msgtl_header.msgt_inline) ? In0P->ports : *((mach_port_t **)In0P->ports), In0P->portsType.msgtl_number, In0P->portsType.msgtl_header.msgt_inline, (In1P->intsType.msgtl_header.msgt_inline) ? In1P->ints : *((int **)In1P->ints), In1P->intsType.msgtl_number, In1P->intsType.msgtl_header.msgt_inline);
	trivfs_end_using_protid(execserver);
}

static mig_routine_t exec_server_routines[] = {
		_Xexec_exec,
		0,
		_Xexec_init,
		_Xexec_setexecdata,
};

mig_external boolean_t exec_server
	(mach_msg_header_t *InHeadP, mach_msg_header_t *OutHeadP)
{
	register mach_msg_header_t *InP =  InHeadP;
	register mig_reply_header_t *OutP = (mig_reply_header_t *) OutHeadP;

	static const mach_msg_type_t RetCodeType = {
		/* msgt_name = */		MACH_MSG_TYPE_INTEGER_32,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	register mig_routine_t routine;

	OutP->Head.msgh_bits = MACH_MSGH_BITS(MACH_MSGH_BITS_REPLY(InP->msgh_bits), 0);
	OutP->Head.msgh_size = sizeof *OutP;
	OutP->Head.msgh_remote_port = InP->msgh_reply_port;
	OutP->Head.msgh_local_port = MACH_PORT_NULL;
	OutP->Head.msgh_seqno = 0;
	OutP->Head.msgh_id = InP->msgh_id + 100;

	OutP->RetCodeType = RetCodeType;

	if ((InP->msgh_id > 30003) || (InP->msgh_id < 30000) ||
	    ((routine = exec_server_routines[InP->msgh_id - 30000]) == 0)) {
		OutP->RetCode = MIG_BAD_ID;
		return FALSE;
	}
	(*routine) (InP, &OutP->Head);
	return TRUE;
}

mig_external mig_routine_t exec_server_routine
	(const mach_msg_header_t *InHeadP)
{
	register int msgh_id;

	msgh_id = InHeadP->msgh_id - 30000;

	if ((msgh_id > 3) || (msgh_id < 0))
		return 0;

	return exec_server_routines[msgh_id];
}

