#ifndef _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#include "fsys_reply_U.h"
#define EXPORT_BOOLEAN
#include <mach/boolean.h>
#include <mach/kern_return.h>
#include <mach/message.h>
#include <mach/notify.h>
#include <mach/mach_types.h>
#include <mach/mig_errors.h>
#include <mach/mig_support.h>
#include <mach/msg_type.h>
/* LINTLIBRARY */

#ifndef	mig_internal
#define	mig_internal	static
#endif

#ifndef	mig_external
#define mig_external
#endif

#ifndef	TypeCheck
#define	TypeCheck 1
#endif

#ifndef	UseExternRCSId
#define	UseExternRCSId		1
#endif

#define msgh_request_port	msgh_remote_port
#define msgh_reply_port		msgh_local_port

#include <mach/std_types.h>
#include <mach/mach_types.h>
#include <device/device_types.h>
#include <device/net_status.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/statfs.h>
#include <sys/resource.h>
#include <sys/utsname.h>
#include <hurd/hurd_types.h>

/* SimpleRoutine fsys_startup_reply */
mig_external kern_return_t fsys_startup_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code,
	mach_port_t realnode,
	mach_msg_type_name_t realnodePoly
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
		mach_msg_type_t realnodeType;
		mach_port_t realnode;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	boolean_t msgh_simple = TRUE;

	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t realnodeType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	if (MACH_MSG_TYPE_PORT_ANY(reply_portPoly))
		msgh_simple = FALSE;

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->realnodeType = realnodeType;

	InP->realnode = realnode;

	if (MACH_MSG_TYPE_PORT_ANY(realnodePoly))
		msgh_simple = FALSE;

	InP->realnodeType.msgt_name = realnodePoly;

	InP->Head.msgh_bits = msgh_simple ?
		MACH_MSGH_BITS(reply_portPoly, 0) :
		(MACH_MSGH_BITS_COMPLEX|
		 MACH_MSGH_BITS(reply_portPoly, 0));
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22100;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 40, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_goaway_reply */
mig_external kern_return_t fsys_goaway_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;


	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->Head.msgh_bits =
		MACH_MSGH_BITS(reply_portPoly, 0);
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22101;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 32, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_getroot_reply */
mig_external kern_return_t fsys_getroot_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code,
	retry_type do_retry,
	string_t retry_name,
	mach_port_t file,
	mach_msg_type_name_t filePoly
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
		mach_msg_type_t do_retryType;
		retry_type do_retry;
		mach_msg_type_t retry_nameType;
		string_t retry_name;
		mach_msg_type_t fileType;
		mach_port_t file;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	boolean_t msgh_simple = TRUE;

	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t do_retryType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t retry_nameType = {
		/* msgt_name = */		MACH_MSG_TYPE_STRING_C,
		/* msgt_size = */		8,
		/* msgt_number = */		1024,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t fileType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	if (MACH_MSG_TYPE_PORT_ANY(reply_portPoly))
		msgh_simple = FALSE;

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->do_retryType = do_retryType;

	InP->do_retry = do_retry;

	InP->retry_nameType = retry_nameType;

	(void) __mig_strncpy(InP->retry_name, retry_name, 1024);

	InP->fileType = fileType;

	InP->file = file;

	if (MACH_MSG_TYPE_PORT_ANY(filePoly))
		msgh_simple = FALSE;

	InP->fileType.msgt_name = filePoly;

	InP->Head.msgh_bits = msgh_simple ?
		MACH_MSGH_BITS(reply_portPoly, 0) :
		(MACH_MSGH_BITS_COMPLEX|
		 MACH_MSGH_BITS(reply_portPoly, 0));
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22102;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 1076, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_getfile_reply */
mig_external kern_return_t fsys_getfile_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code,
	mach_port_t file,
	mach_msg_type_name_t filePoly
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
		mach_msg_type_t fileType;
		mach_port_t file;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	boolean_t msgh_simple = TRUE;

	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t fileType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	if (MACH_MSG_TYPE_PORT_ANY(reply_portPoly))
		msgh_simple = FALSE;

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->fileType = fileType;

	InP->file = file;

	if (MACH_MSG_TYPE_PORT_ANY(filePoly))
		msgh_simple = FALSE;

	InP->fileType.msgt_name = filePoly;

	InP->Head.msgh_bits = msgh_simple ?
		MACH_MSGH_BITS(reply_portPoly, 0) :
		(MACH_MSGH_BITS_COMPLEX|
		 MACH_MSGH_BITS(reply_portPoly, 0));
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22103;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 40, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_syncfs_reply */
mig_external kern_return_t fsys_syncfs_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t retocde
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t retocdeType;
		kern_return_t retocde;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;


	static const mach_msg_type_t retocdeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	InP->retocdeType = retocdeType;

	InP->retocde = retocde;

	InP->Head.msgh_bits =
		MACH_MSGH_BITS(reply_portPoly, 0);
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22104;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 32, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_set_options_reply */
mig_external kern_return_t fsys_set_options_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;


	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->Head.msgh_bits =
		MACH_MSGH_BITS(reply_portPoly, 0);
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22105;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 32, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_getpriv_reply */
mig_external kern_return_t fsys_getpriv_reply
(
	mach_port_t reply_port_,
	mach_msg_type_name_t reply_port_Poly,
	kern_return_t return_code,
	mach_port_t host_priv,
	mach_msg_type_name_t host_privPoly,
	mach_port_t device_master,
	mach_msg_type_name_t device_masterPoly,
	mach_port_t fstask,
	mach_msg_type_name_t fstaskPoly
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
		mach_msg_type_t host_privType;
		mach_port_t host_priv;
		mach_msg_type_t device_masterType;
		mach_port_t device_master;
		mach_msg_type_t fstaskType;
		mach_port_t fstask;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	boolean_t msgh_simple = TRUE;

	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t host_privType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t device_masterType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_t fstaskType = {
		/* msgt_name = */		-1,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	if (MACH_MSG_TYPE_PORT_ANY(reply_port_Poly))
		msgh_simple = FALSE;

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->host_privType = host_privType;

	InP->host_priv = host_priv;

	if (MACH_MSG_TYPE_PORT_ANY(host_privPoly))
		msgh_simple = FALSE;

	InP->host_privType.msgt_name = host_privPoly;

	InP->device_masterType = device_masterType;

	InP->device_master = device_master;

	if (MACH_MSG_TYPE_PORT_ANY(device_masterPoly))
		msgh_simple = FALSE;

	InP->device_masterType.msgt_name = device_masterPoly;

	InP->fstaskType = fstaskType;

	InP->fstask = fstask;

	if (MACH_MSG_TYPE_PORT_ANY(fstaskPoly))
		msgh_simple = FALSE;

	InP->fstaskType.msgt_name = fstaskPoly;

	InP->Head.msgh_bits = msgh_simple ?
		MACH_MSGH_BITS(reply_port_Poly, 0) :
		(MACH_MSGH_BITS_COMPLEX|
		 MACH_MSGH_BITS(reply_port_Poly, 0));
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port_;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22106;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 56, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_init_reply */
mig_external kern_return_t fsys_init_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;


	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->Head.msgh_bits =
		MACH_MSGH_BITS(reply_portPoly, 0);
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22107;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 32, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_forward_reply */
mig_external kern_return_t fsys_forward_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;


	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->Head.msgh_bits =
		MACH_MSGH_BITS(reply_portPoly, 0);
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22108;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, 32, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}

/* SimpleRoutine fsys_get_options_reply */
mig_external kern_return_t fsys_get_options_reply
(
	mach_port_t reply_port,
	mach_msg_type_name_t reply_portPoly,
	kern_return_t return_code,
	data_t options,
	mach_msg_type_number_t optionsCnt
)
{
	typedef struct {
		mach_msg_header_t Head;
		mach_msg_type_t return_codeType;
		kern_return_t return_code;
		mach_msg_type_long_t optionsType;
		char options[2048];
	} Request;

	union {
		Request In;
	} Mess;

	register Request *InP = &Mess.In;

	boolean_t msgh_simple = TRUE;
	unsigned int msgh_size;

	static const mach_msg_type_t return_codeType = {
		/* msgt_name = */		2,
		/* msgt_size = */		32,
		/* msgt_number = */		1,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		FALSE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	};

	static const mach_msg_type_long_t optionsType = {
	{
		/* msgt_name = */		0,
		/* msgt_size = */		0,
		/* msgt_number = */		0,
		/* msgt_inline = */		TRUE,
		/* msgt_longform = */		TRUE,
		/* msgt_deallocate = */		FALSE,
		/* msgt_unused = */		0
	},
		/* msgtl_name = */	8,
		/* msgtl_size = */	8,
		/* msgtl_number = */	2048,
	};

	if (MACH_MSG_TYPE_PORT_ANY(reply_portPoly))
		msgh_simple = FALSE;

	InP->return_codeType = return_codeType;

	InP->return_code = return_code;

	InP->optionsType = optionsType;

	if (optionsCnt > 2048) {
		InP->optionsType.msgtl_header.msgt_inline = FALSE;
		*((char **)InP->options) = options;
		msgh_simple = FALSE;
	}
	else {
		memcpy(InP->options, options, optionsCnt);
	}

	InP->optionsType.msgtl_number = optionsCnt;

	msgh_size = 44 + ((InP->optionsType.msgtl_header.msgt_inline) ? (optionsCnt + 3) & ~3 : sizeof(char *));
	InP->Head.msgh_bits = msgh_simple ?
		MACH_MSGH_BITS(reply_portPoly, 0) :
		(MACH_MSGH_BITS_COMPLEX|
		 MACH_MSGH_BITS(reply_portPoly, 0));
	/* msgh_size passed as argument */
	InP->Head.msgh_request_port = reply_port;
	InP->Head.msgh_reply_port = MACH_PORT_NULL;
	InP->Head.msgh_seqno = 0;
	InP->Head.msgh_id = 22109;

	return __mach_msg(&InP->Head, MACH_SEND_MSG|MACH_MSG_OPTION_NONE, msgh_size, 0, MACH_PORT_NULL, MACH_MSG_TIMEOUT_NONE, MACH_PORT_NULL);
}
